MCP Tools Reference: apihub.googleapis.com

Tool: list_deployments

List deployment resources in the API hub.

The following sample demonstrate how to use curl to invoke the list_deployments MCP tool.

Curl Request
                  
curl --location 'https://apihub.REGION.rep.googleapis.com/mcp' \
--header 'content-type: application/json' \
--header 'accept: application/json, text/event-stream' \
--data '{
  "method": "tools/call",
  "params": {
    "name": "list_deployments",
    "arguments": {
      // provide these details according to the tool's MCP specification
    }
  },
  "jsonrpc": "2.0",
  "id": 1
}'
                

Where, REGION is the supported API hub region. For more information, see Supported regions.

Input Schema

The ListDeployments method's request.

ListDeploymentsRequest

JSON representation
{
  "parent": string,
  "filter": string,
  "pageSize": integer,
  "pageToken": string
}
Fields
parent

string

Required. The parent, which owns this collection of deployment resources. Format: projects/{project}/locations/{location}

filter

string

Optional. An expression that filters the list of Deployments.

A filter expression consists of a field name, a comparison operator, and a value for filtering. The value must be a string. The comparison operator must be one of: <, > or =. Filters are not case sensitive.

The following fields in the Deployments are eligible for filtering:

  • display_name - The display name of the Deployment. Allowed comparison operators: =.
  • create_time - The time at which the Deployment was created. The value should be in the (RFC3339)[https://tools.ietf.org/html/rfc3339] format. Allowed comparison operators: > and <.
  • resource_uri - A URI to the deployment resource. Allowed comparison operators: =.
  • api_versions - The API versions linked to this deployment. Allowed comparison operators: :.
  • source_project - The project/organization at source for the deployment. Allowed comparison operators: =.
  • source_environment - The environment at source for the deployment. Allowed comparison operators: =.
  • deployment_type.enum_values.values.id - The allowed value id of the deployment_type attribute associated with the Deployment. Allowed comparison operators: :.
  • deployment_type.enum_values.values.display_name - The allowed value display name of the deployment_type attribute associated with the Deployment. Allowed comparison operators: :.
  • slo.string_values.values -The allowed string value of the slo attribute associated with the deployment. Allowed comparison operators: :.
  • environment.enum_values.values.id - The allowed value id of the environment attribute associated with the deployment. Allowed comparison operators: :.
  • environment.enum_values.values.display_name - The allowed value display name of the environment attribute associated with the deployment. Allowed comparison operators: :.
  • attributes.projects/test-project-id/locations/test-location-id/ attributes/user-defined-attribute-id.enum_values.values.id - The allowed value id of the user defined enum attribute associated with the Resource. Allowed comparison operator is :. Here user-defined-attribute-enum-id is a placeholder that can be replaced with any user defined enum attribute name.
  • attributes.projects/test-project-id/locations/test-location-id/ attributes/user-defined-attribute-id.enum_values.values.display_name
  • The allowed value display name of the user defined enum attribute associated with the Resource. Allowed comparison operator is :. Here user-defined-attribute-enum-display-name is a placeholder that can be replaced with any user defined enum attribute enum name.
  • attributes.projects/test-project-id/locations/test-location-id/ attributes/user-defined-attribute-id.string_values.values - The allowed value of the user defined string attribute associated with the Resource. Allowed comparison operator is :. Here user-defined-attribute-string is a placeholder that can be replaced with any user defined string attribute name.
  • attributes.projects/test-project-id/locations/test-location-id/ attributes/user-defined-attribute-id.json_values.values - The allowed value of the user defined JSON attribute associated with the Resource. Allowed comparison operator is :. Here user-defined-attribute-json is a placeholder that can be replaced with any user defined JSON attribute name.

A filter function is also supported in the filter string. The filter function is id(name). The id(name) function returns the id of the resource name. For example, id(name) = \"deployment-1\" is equivalent to name = \"projects/test-project-id/locations/test-location-id/deployments/deployment-1\" provided the parent is projects/test-project-id/locations/test-location-id.

Expressions are combined with either AND logic operator or OR logical operator but not both of them together i.e. only one of the AND or OR operator can be used throughout the filter string and both the operators cannot be used together. No other logical operators are supported. At most three filter fields are allowed in the filter string and if provided more than that then INVALID_ARGUMENT error is returned by the API.

Here are a few examples:

  • environment.enum_values.values.id: staging-id - The allowed value id of the environment attribute associated with the Deployment is staging-id.
  • environment.enum_values.values.display_name: \"Staging Deployment\" - The allowed value display name of the environment attribute associated with the Deployment is Staging Deployment.
  • environment.enum_values.values.id: production-id AND create_time < \"2021-08-15T14:50:00Z\" AND create_time > \"2021-08-10T12:00:00Z\" - The allowed value id of the environment attribute associated with the Deployment is production-id and Deployment was created before 2021-08-15 14:50:00 UTC and after 2021-08-10 12:00:00 UTC.
  • environment.enum_values.values.id: production-id OR slo.string_values.values: \"99.99%\"
  • The allowed value id of the environment attribute Deployment is production-id or string value of the slo attribute is 99.99%.
  • environment.enum_values.values.id: staging-id AND attributes.projects/test-project-id/locations/test-location-id/ attributes/17650f90-4a29-4971-b3c0-d5532da3764b.string_values.values: test - The filter string specifies that the allowed value id of the environment attribute associated with the Deployment is staging-id and the value of the user defined attribute of type string is test.
pageSize

integer

Optional. The maximum number of deployment resources to return. The service may return fewer than this value. If unspecified, at most 50 deployments will be returned. The maximum value is 1000; values above 1000 will be coerced to 1000.

pageToken

string

Optional. A page token, received from a previous ListDeployments call. Provide this to retrieve the subsequent page.

When paginating, all other parameters (except page_size) provided to ListDeployments must match the call that provided the page token.

Output Schema

The ListDeployments method's response.

ListDeploymentsResponse

JSON representation
{
  "deployments": [
    {
      object (Deployment)
    }
  ],
  "nextPageToken": string
}
Fields
deployments[]

object (Deployment)

The deployment resources present in the API hub.

nextPageToken

string

A token, which can be sent as page_token to retrieve the next page. If this field is omitted, there are no subsequent pages.

Deployment

JSON representation
{
  "name": string,
  "displayName": string,
  "description": string,
  "documentation": {
    object (Documentation)
  },
  "deploymentType": {
    object (AttributeValues)
  },
  "resourceUri": string,
  "endpoints": [
    string
  ],
  "apiVersions": [
    string
  ],
  "createTime": string,
  "updateTime": string,
  "slo": {
    object (AttributeValues)
  },
  "environment": {
    object (AttributeValues)
  },
  "attributes": {
    string: {
      object (AttributeValues)
    },
    ...
  },
  "sourceMetadata": [
    {
      object (SourceMetadata)
    }
  ],
  "managementUrl": {
    object (AttributeValues)
  },
  "sourceUri": {
    object (AttributeValues)
  },
  "sourceProject": string,
  "sourceEnvironment": string
}
Fields
name

string

Identifier. The name of the deployment.

Format: projects/{project}/locations/{location}/deployments/{deployment}

displayName

string

Required. The display name of the deployment.

description

string

Optional. The description of the deployment.

documentation

object (Documentation)

Optional. The documentation of the deployment.

deploymentType

object (AttributeValues)

Required. The type of deployment. This maps to the following system defined attribute: projects/{project}/locations/{location}/attributes/system-deployment-type attribute. The number of values for this attribute will be based on the cardinality of the attribute. The same can be retrieved via GetAttribute API. All values should be from the list of allowed values defined for the attribute.

resourceUri

string

Required. The resource URI identifies the deployment within its gateway. For Apigee gateways, its recommended to use the format: organizations/{org}/environments/{env}/apis/{api}. For ex: if a proxy with name orders is deployed in staging environment of cymbal organization, the resource URI would be: organizations/cymbal/environments/staging/apis/orders.

endpoints[]

string

Required. The endpoints at which this deployment resource is listening for API requests. This could be a list of complete URIs, hostnames or an IP addresses.

apiVersions[]

string

Output only. The API versions linked to this deployment. Note: A particular deployment could be linked to multiple different API versions (of same or different APIs).

createTime

string (Timestamp format)

Output only. The time at which the deployment was created.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

updateTime

string (Timestamp format)

Output only. The time at which the deployment was last updated.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

slo

object (AttributeValues)

Optional. The SLO for this deployment. This maps to the following system defined attribute: projects/{project}/locations/{location}/attributes/system-slo attribute. The number of values for this attribute will be based on the cardinality of the attribute. The same can be retrieved via GetAttribute API. All values should be from the list of allowed values defined for the attribute.

environment

object (AttributeValues)

Optional. The environment mapping to this deployment. This maps to the following system defined attribute: projects/{project}/locations/{location}/attributes/system-environment attribute. The number of values for this attribute will be based on the cardinality of the attribute. The same can be retrieved via GetAttribute API. All values should be from the list of allowed values defined for the attribute.

attributes

map (key: string, value: object (AttributeValues))

Optional. The list of user defined attributes associated with the deployment resource. The key is the attribute name. It will be of the format: projects/{project}/locations/{location}/attributes/{attribute}. The value is the attribute values associated with the resource.

An object containing a list of "key": value pairs. Example: { "name": "wrench", "mass": "1.3kg", "count": "3" }.

sourceMetadata[]

object (SourceMetadata)

Output only. The list of sources and metadata from the sources of the deployment.

managementUrl

object (AttributeValues)

Optional. The uri where users can navigate to for the management of the deployment. This maps to the following system defined attribute: projects/{project}/locations/{location}/attributes/system-management-url The number of values for this attribute will be based on the cardinality of the attribute. The same can be retrieved via GetAttribute API. The value of the attribute should be a valid URL.

sourceUri

object (AttributeValues)

Optional. The uri where additional source specific information for this deployment can be found. This maps to the following system defined attribute: projects/{project}/locations/{location}/attributes/system-source-uri The number of values for this attribute will be based on the cardinality of the attribute. The same can be retrieved via GetAttribute API. The value of the attribute should be a valid URI, and in case of Cloud Storage URI, it should point to a Cloud Storage object, not a directory.

sourceProject

string

Optional. The project to which the deployment belongs. For Google Cloud gateways, this will refer to the project identifier. For others like Edge/OPDK, this will refer to the org identifier.

sourceEnvironment

string

Optional. The environment at source for the deployment. For example: prod, dev, staging, etc.

Documentation

JSON representation
{
  "externalUri": string
}
Fields
externalUri

string

Optional. The uri of the externally hosted documentation.

AttributeValues

JSON representation
{
  "attribute": string,

  // Union field Value can be only one of the following:
  "enumValues": {
    object (EnumAttributeValues)
  },
  "stringValues": {
    object (StringAttributeValues)
  },
  "jsonValues": {
    object (StringAttributeValues)
  },
  "uriValues": {
    object (StringAttributeValues)
  }
  // End of list of possible types for union field Value.
}
Fields
attribute

string

Output only. The name of the attribute. Format: projects/{project}/locations/{location}/attributes/{attribute}

Union field Value. The attribute values associated with the resource. Value can be only one of the following:
enumValues

object (EnumAttributeValues)

The attribute values associated with a resource in case attribute data type is enum.

stringValues

object (StringAttributeValues)

The attribute values associated with a resource in case attribute data type is string.

jsonValues

object (StringAttributeValues)

The attribute values associated with a resource in case attribute data type is JSON.

uriValues

object (StringAttributeValues)

The attribute values associated with a resource in case attribute data type is URL, URI or IP, like gs://bucket-name/object-name.

EnumAttributeValues

JSON representation
{
  "values": [
    {
      object (AllowedValue)
    }
  ]
}
Fields
values[]

object (AllowedValue)

Required. The attribute values in case attribute data type is enum.

AllowedValue

JSON representation
{
  "id": string,
  "displayName": string,
  "description": string,
  "immutable": boolean
}
Fields
id

string

Required. The ID of the allowed value. * If provided, the same will be used. The service will throw an error if the specified id is already used by another allowed value in the same attribute resource. * If not provided, a system generated id derived from the display name will be used. In this case, the service will handle conflict resolution by adding a system generated suffix in case of duplicates.

This value should be 4-63 characters, and valid characters are /[a-z][0-9]-/.

displayName

string

Required. The display name of the allowed value.

description

string

Optional. The detailed description of the allowed value.

immutable

boolean

Optional. When set to true, the allowed value cannot be updated or deleted by the user. It can only be true for System defined attributes.

StringAttributeValues

JSON representation
{
  "values": [
    string
  ]
}
Fields
values[]

string

Required. The attribute values in case attribute data type is string or JSON.

Timestamp

JSON representation
{
  "seconds": string,
  "nanos": integer
}
Fields
seconds

string (int64 format)

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z).

nanos

integer

Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive.

AttributesEntry

JSON representation
{
  "key": string,
  "value": {
    object (AttributeValues)
  }
}
Fields
key

string

value

object (AttributeValues)

SourceMetadata

JSON representation
{
  "sourceType": enum (SourceType),
  "originalResourceId": string,
  "originalResourceCreateTime": string,
  "originalResourceUpdateTime": string,

  // Union field source can be only one of the following:
  "pluginInstanceActionSource": {
    object (PluginInstanceActionSource)
  }
  // End of list of possible types for union field source.
}
Fields
sourceType

enum (SourceType)

Output only. The type of the source.

originalResourceId

string

Output only. The unique identifier of the resource at the source.

originalResourceCreateTime

string (Timestamp format)

Output only. The time at which the resource was created at the source.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

originalResourceUpdateTime

string (Timestamp format)

Output only. The time at which the resource was last updated at the source.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

Union field source. The source of the resource. source can be only one of the following:
pluginInstanceActionSource

object (PluginInstanceActionSource)

Output only. The source of the resource is a plugin instance action.

PluginInstanceActionSource

JSON representation
{
  "pluginInstance": string,
  "actionId": string
}
Fields
pluginInstance

string

Output only. The resource name of the source plugin instance. Format is projects/{project}/locations/{location}/plugins/{plugin}/instances/{instance}

actionId

string

Output only. The id of the plugin instance action.

Tool Annotations

Destructive Hint: ❌ | Idempotent Hint: ✅ | Read Only Hint: ✅ | Open World Hint: ❌